(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/common'), require('@angular/core')) :
    typeof define === 'function' && define.amd ? define('@ng-tangram/components/badge', ['exports', '@angular/common', '@angular/core'], factory) :
    (global = global || self, factory((global.nt = global.nt || {}, global.nt.components = global.nt.components || {}, global.nt.components.badge = {}), global.ng.common, global.ng.core));
}(this, (function (exports, common, core) { 'use strict';

    var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
        var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
        if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
        else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
        return c > 3 && r && Object.defineProperty(target, key, r), r;
    };
    var __param = (this && this.__param) || function (paramIndex, decorator) {
        return function (target, key) { decorator(target, key, paramIndex); }
    };
    var NtBadgeComponent = (function () {
        function NtBadgeComponent(platformId, _elementRef, _renderer) {
            this.platformId = platformId;
            this._elementRef = _elementRef;
            this._renderer = _renderer;
            this._type = 'static';
            this.color = '';
            this.class = '';
        }
        Object.defineProperty(NtBadgeComponent.prototype, "type", {
            get: function () { return this._type; },
            set: function (value) {
                if (value === 'float' || value === 'notify') {
                    this._resetPosition();
                }
                else {
                    this._clearPosition();
                }
                this._type = value;
            },
            enumerable: true,
            configurable: true
        });
        NtBadgeComponent.prototype.ngAfterViewInit = function () {
            this._resetPosition();
        };
        NtBadgeComponent.prototype.ngOnDestroy = function () {
            this._clearPosition();
        };
        NtBadgeComponent.prototype._resetPosition = function () {
            if (common.isPlatformBrowser(this.platformId)) {
                var style = window.getComputedStyle(this._elementRef.nativeElement.parentElement);
                if (style.position !== 'absolute' || style.position !== 'absolute') {
                    this._originalPosition = style.position;
                    this._renderer.setStyle(this._elementRef.nativeElement.parentElement, 'position', 'relative');
                }
            }
        };
        NtBadgeComponent.prototype._clearPosition = function () {
            if (common.isPlatformBrowser(this.platformId)) {
                if (this._originalPosition) {
                    this._renderer.removeStyle(this._elementRef.nativeElement.parentElement, 'position');
                }
            }
        };
        NtBadgeComponent.ctorParameters = function () { return [
            { type: Object, decorators: [{ type: core.Inject, args: [core.PLATFORM_ID,] }] },
            { type: core.ElementRef },
            { type: core.Renderer2 }
        ]; };
        __decorate([
            core.Input()
        ], NtBadgeComponent.prototype, "color", void 0);
        __decorate([
            core.Input()
        ], NtBadgeComponent.prototype, "class", void 0);
        __decorate([
            core.Input()
        ], NtBadgeComponent.prototype, "type", null);
        NtBadgeComponent = __decorate([
            core.Component({
                selector: 'nt-badge, [nt-badge]',
                template: "<ng-content></ng-content>",
                encapsulation: core.ViewEncapsulation.None,
                host: {
                    '[class]': '["badge", color, class].join(" ")',
                    '[class.badge-float]': 'type === "float"',
                    '[class.badge-notify]': 'type === "notify"'
                }
            }),
            __param(0, core.Inject(core.PLATFORM_ID))
        ], NtBadgeComponent);
        return NtBadgeComponent;
    }());

    var __decorate$1 = (this && this.__decorate) || function (decorators, target, key, desc) {
        var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
        if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
        else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
        return c > 3 && r && Object.defineProperty(target, key, r), r;
    };
    var NtBadgeModule = (function () {
        function NtBadgeModule() {
        }
        NtBadgeModule = __decorate$1([
            core.NgModule({
                imports: [common.CommonModule],
                declarations: [NtBadgeComponent],
                exports: [NtBadgeComponent]
            })
        ], NtBadgeModule);
        return NtBadgeModule;
    }());

    exports.NtBadgeComponent = NtBadgeComponent;
    exports.NtBadgeModule = NtBadgeModule;

    Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=badge.umd.js.map
