(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/cdk/observers'), require('@angular/common'), require('@angular/core'), require('@ng-tangram/components/core'), require('@ng-tangram/components/dropdown'), require('rxjs'), require('@angular/cdk/overlay')) :
    typeof define === 'function' && define.amd ? define('@ng-tangram/components/popover', ['exports', '@angular/cdk/observers', '@angular/common', '@angular/core', '@ng-tangram/components/core', '@ng-tangram/components/dropdown', 'rxjs', '@angular/cdk/overlay'], factory) :
    (global = global || self, factory((global.nt = global.nt || {}, global.nt.components = global.nt.components || {}, global.nt.components.popover = {}), global.ng.cdk.observers, global.ng.common, global.ng.core, global.nt.components.core, global.nt.components.dropdown, global.rxjs, global.ng.cdk.overlay));
}(this, (function (exports, observers, common, core, core$1, dropdown, rxjs, overlay) { 'use strict';

    var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
        var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
        if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
        else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
        return c > 3 && r && Object.defineProperty(target, key, r), r;
    };
    var __param = (this && this.__param) || function (paramIndex, decorator) {
        return function (target, key) { decorator(target, key, paramIndex); }
    };
    var NT_POPOVER_PARENT_COMPONENT = new core.InjectionToken('nt-popover-parent-component');
    var NtPopoverPaneComponent = (function () {
        function NtPopoverPaneComponent(_contentObserver, _elementRef, _parent) {
            this._contentObserver = _contentObserver;
            this._elementRef = _elementRef;
            this._parent = _parent;
            this._contentChange = new rxjs.Subject();
        }
        Object.defineProperty(NtPopoverPaneComponent.prototype, "contentChanged", {
            get: function () {
                return this._contentChange.asObservable();
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(NtPopoverPaneComponent.prototype, "textContent", {
            get: function () {
                return (this._elementRef.nativeElement.textContent || '').trim();
            },
            enumerable: true,
            configurable: true
        });
        NtPopoverPaneComponent.prototype.ngAfterContentInit = function () {
            var _this = this;
            this._contentSubscription = this._contentObserver
                .observe(this._elementRef)
                .subscribe(function () { return _this._checkContentChange(); });
        };
        NtPopoverPaneComponent.prototype.ngOnDestroy = function () {
            if (this._contentSubscription) {
                this._contentSubscription.unsubscribe();
            }
        };
        NtPopoverPaneComponent.prototype._checkContentChange = function () {
            if (this._parent.overlay.opened) {
                var cdkConnectedOverlay = this._parent.overlay.cdkConnectedOverlay;
                if (cdkConnectedOverlay && cdkConnectedOverlay.overlayRef) {
                    cdkConnectedOverlay.overlayRef.updatePosition();
                }
            }
        };
        NtPopoverPaneComponent.ctorParameters = function () { return [
            { type: observers.ContentObserver },
            { type: core.ElementRef },
            { type: undefined, decorators: [{ type: core.Inject, args: [NT_POPOVER_PARENT_COMPONENT,] }] }
        ]; };
        NtPopoverPaneComponent = __decorate([
            core.Component({
                selector: 'nt-popover-pane, [nt-popover-pane]',
                template: "\n    <ng-content></ng-content>\n  ",
                encapsulation: core.ViewEncapsulation.None
            }),
            __param(2, core.Inject(NT_POPOVER_PARENT_COMPONENT))
        ], NtPopoverPaneComponent);
        return NtPopoverPaneComponent;
    }());

    var __decorate$1 = (this && this.__decorate) || function (decorators, target, key, desc) {
        var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
        if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
        else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
        return c > 3 && r && Object.defineProperty(target, key, r), r;
    };
    var NtPopoverComponent = (function () {
        function NtPopoverComponent(_elementRef) {
            this._elementRef = _elementRef;
            this._title = '';
            this.position = core$1.NtOverlayPosition.Top;
            this.confirm = new core.EventEmitter();
            this.cancel = new core.EventEmitter();
            this.afterOpen = new core.EventEmitter();
            this.afterClosed = new core.EventEmitter();
            this.beforeOpen = new core.EventEmitter();
            this.beforeClosed = new core.EventEmitter();
            this.positionChange = new core.EventEmitter();
            this.origin = new overlay.CdkOverlayOrigin(this._elementRef);
        }
        NtPopoverComponent_1 = NtPopoverComponent;
        Object.defineProperty(NtPopoverComponent.prototype, "title", {
            get: function () { return this._title; },
            set: function (value) { this._title = value; },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(NtPopoverComponent.prototype, "template", {
            get: function () { return this._template; },
            set: function (value) { this._template = value; },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(NtPopoverComponent.prototype, "popover", {
            set: function (value) {
                if (value instanceof core.TemplateRef) {
                    this._template = value;
                }
                else {
                    this._title = value;
                    this._template = null;
                }
            },
            enumerable: true,
            configurable: true
        });
        NtPopoverComponent.prototype._afterOpen = function (event) {
            this.afterOpen.next(event);
        };
        NtPopoverComponent.prototype._afterClosed = function (event) {
            this.afterClosed.next(event);
        };
        NtPopoverComponent.prototype._beforeOpen = function (event) {
            this.beforeOpen.next(event);
        };
        NtPopoverComponent.prototype._beforeClosed = function (event) {
            this.beforeClosed.next(event);
        };
        NtPopoverComponent.prototype._positionChange = function (change) {
            this.positionChange.next(change);
        };
        var NtPopoverComponent_1;
        NtPopoverComponent.ctorParameters = function () { return [
            { type: core.ElementRef }
        ]; };
        __decorate$1([
            core.Input()
        ], NtPopoverComponent.prototype, "title", null);
        __decorate$1([
            core.Input()
        ], NtPopoverComponent.prototype, "template", null);
        __decorate$1([
            core.Input('nt-popover')
        ], NtPopoverComponent.prototype, "popover", null);
        __decorate$1([
            core.Input()
        ], NtPopoverComponent.prototype, "position", void 0);
        __decorate$1([
            core.Output()
        ], NtPopoverComponent.prototype, "confirm", void 0);
        __decorate$1([
            core.Output()
        ], NtPopoverComponent.prototype, "cancel", void 0);
        __decorate$1([
            core.Output()
        ], NtPopoverComponent.prototype, "afterOpen", void 0);
        __decorate$1([
            core.Output()
        ], NtPopoverComponent.prototype, "afterClosed", void 0);
        __decorate$1([
            core.Output()
        ], NtPopoverComponent.prototype, "beforeOpen", void 0);
        __decorate$1([
            core.Output()
        ], NtPopoverComponent.prototype, "beforeClosed", void 0);
        __decorate$1([
            core.Output()
        ], NtPopoverComponent.prototype, "positionChange", void 0);
        __decorate$1([
            core.ViewChild(core$1.NtOverlayComponent, { static: true })
        ], NtPopoverComponent.prototype, "overlay", void 0);
        NtPopoverComponent = NtPopoverComponent_1 = __decorate$1([
            core.Component({
                selector: '[nt-popover]',
                template: "<ng-content></ng-content>\n<nt-overlay\n  arrow\n  [origin]=\"origin\"\n  [position]=\"position\"\n  (afterOpen)=\"_afterOpen($event)\"\n  (afterClosed)=\"_afterClosed($event)\"\n  (beforeOpen)=\"_beforeOpen($event)\"\n  (beforeClosed)=\"_beforeClosed($event)\"\n  (positionChange)=\"_positionChange($event)\">\n  <div class=\"nt-popover\">\n    <div class=\"nt-popover-title\" *ngIf=\"template\"><ng-container *ngTemplateOutlet=\"template\"></ng-container></div>\n    <div class=\"nt-popover-title\" *ngIf=\"!template\" [innerHtml]=\"title\"></div>\n    <div class=\"nt-popover-pane\">\n      <ng-content select=\"nt-popover-pane\"></ng-content>\n    </div>\n  </div>\n</nt-overlay>\n",
                encapsulation: core.ViewEncapsulation.None,
                host: {
                    '(click)': 'overlay.toggle()'
                },
                providers: [
                    { provide: NT_POPOVER_PARENT_COMPONENT, useExisting: NtPopoverComponent_1 }
                ]
            })
        ], NtPopoverComponent);
        return NtPopoverComponent;
    }());

    var __decorate$2 = (this && this.__decorate) || function (decorators, target, key, desc) {
        var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
        if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
        else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
        return c > 3 && r && Object.defineProperty(target, key, r), r;
    };
    var NtPopoverModule = (function () {
        function NtPopoverModule() {
        }
        NtPopoverModule = __decorate$2([
            core.NgModule({
                imports: [common.CommonModule, observers.ObserversModule, core$1.NtOverlayModule, dropdown.NtDropdownModule],
                exports: [NtPopoverComponent, NtPopoverPaneComponent],
                declarations: [NtPopoverComponent, NtPopoverPaneComponent]
            })
        ], NtPopoverModule);
        return NtPopoverModule;
    }());

    exports.NT_POPOVER_PARENT_COMPONENT = NT_POPOVER_PARENT_COMPONENT;
    exports.NtPopoverComponent = NtPopoverComponent;
    exports.NtPopoverModule = NtPopoverModule;
    exports.NtPopoverPaneComponent = NtPopoverPaneComponent;

    Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=popover.umd.js.map
