import { AnimationEvent } from '@angular/animations';
import { CdkConnectedOverlay, CdkOverlayOrigin, ConnectedOverlayPositionChange, ConnectionPositionPair } from '@angular/cdk/overlay';
import { Location } from '@angular/common';
import { AfterViewInit, ChangeDetectorRef, EventEmitter, OnChanges, OnDestroy, Renderer2, SimpleChanges } from '@angular/core';
import { NtOverlayPosition } from './overlay-positions';
export declare class NtOverlayComponent implements AfterViewInit, OnChanges, OnDestroy {
    private _renderer;
    private _changeDetectorRef;
    private readonly _destroy;
    private _debounceClose;
    private _positionChange;
    private _locationChanges;
    private _outsideClickSubscription;
    private _opened;
    readonly opened: boolean;
    private _markClosed;
    private _origin;
    origin: CdkOverlayOrigin;
    private _position;
    position: NtOverlayPosition;
    private _positionPairs;
    positionPairs: ConnectionPositionPair[];
    private _paddingClass;
    readonly paddingClass: string;
    private _fixed;
    fixed: boolean;
    private _arrow;
    arrow: boolean;
    private _nospacing;
    nospacing: boolean;
    private _overlayClass;
    overlayClass: string;
    private _backdrop;
    backdrop: boolean;
    cdkConnectedOverlay: CdkConnectedOverlay;
    afterOpen: EventEmitter<any>;
    afterClosed: EventEmitter<any>;
    beforeOpen: EventEmitter<any>;
    beforeClosed: EventEmitter<any>;
    overlayEnter: EventEmitter<any>;
    overlayLeave: EventEmitter<any>;
    positionChange: EventEmitter<ConnectedOverlayPositionChange>;
    keydownEvents: EventEmitter<KeyboardEvent>;
    constructor(_renderer: Renderer2, _changeDetectorRef: ChangeDetectorRef, location: Location);
    ngAfterViewInit(): void;
    ngOnChanges(changes: SimpleChanges): void;
    ngOnDestroy(): void;
    private _setPosition;
    private _subscribeOutsideClickEvent;
    private _unsubscribeOutsideClickEvent;
    open(): void;
    close(): void;
    toggle(): void;
    onOverlayPositionChange(event: ConnectedOverlayPositionChange): void;
    markOpen(): void;
    markClose(): void;
    onAnimationStart(event: AnimationEvent): void;
    onAnimationDone(event: AnimationEvent): void;
    private _setContainerStyles;
}
