import { AfterContentInit, ChangeDetectorRef, EventEmitter } from '@angular/core';
import { DateAdapter, NtDateFormats } from '@ng-tangram/components/core';
import { NtDatePickerCell } from './datepicker-models';
export declare class NtDatePickerYearComponent<D> implements AfterContentInit {
    private _changeDetectorRef;
    private _dateAdapter;
    private _dateFormats;
    _months: NtDatePickerCell[][];
    _todayMonth: number | null;
    _selectedMonth: number | null;
    private _activeDate;
    private _selected;
    private _minDate;
    private _maxDate;
    activeDate: D;
    readonly activeYear: number | null;
    selected: D | null;
    minDate: D | null;
    maxDate: D | null;
    dateFilter: (date: D) => boolean;
    readonly selectedChange: EventEmitter<D>;
    readonly monthSelected: EventEmitter<D>;
    constructor(_changeDetectorRef: ChangeDetectorRef, _dateAdapter: DateAdapter<D>, _dateFormats: NtDateFormats);
    ngAfterContentInit(): void;
    _init(): void;
    _monthSelected(month: number): void;
    private _createCellForMonth;
    private _shouldEnableMonth;
    private _isYearAndMonthAfterMaxDate;
    private _isYearAndMonthBeforeMinDate;
    private _getMonthInCurrentYear;
    private _getValidDateOrNull;
}
